/**
 * 
 */
package com.andframework.business;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Bitmap.Config;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.ImageView;

import com.andframework.common.ImageDownLoadListener;
import com.andframework.network.IHttpConnect;
import com.andframework.ui.CustomImageView;
import com.andframework.util.Util;
import com.andframework.zmfile.ZMFile;
import com.andframework.zmfile.ZMFilePath;

/**
 * @author xudeliang
 *图片异步业务
 */
public  class LoadImageTsk extends AsyncTask<String,  String,  Bitmap>
{
	private IHttpConnect iCon;
	public long timestmp;//时间戳
	public String picUrl;
	private FinishedListner flistner;
	private CustomImageView civ;
	//是否构造图片
	private boolean isBuildImage=true;
	
	
	/*
	 * 
	 * 仅使用下载bitmap
	 * 
	 * */
	
	private ImageDownLoadListener bitmaplistener;
	
	public void setImageView(CustomImageView civ)
	{
		this.civ = civ;
	}
	
	public void setBuildImage(boolean isbiuld)
	{
		isBuildImage = isbiuld;
	}
	
	public boolean isBuildImage()
	{
		return isBuildImage;
	}
	
	public void setImageDownLoadListener(ImageDownLoadListener bitmaplistener)
	{
		this.bitmaplistener=bitmaplistener;
	}
	
	public void iExcute()
	{
		if(null!=picUrl)
		{
			this.execute(picUrl);
			//PicDownTaskManager.getInst().postTask(this);
		}
		
	}
	public void setFinishedListner(FinishedListner fl)
	{
		flistner=fl;
	}
	
	@Override
	protected Bitmap doInBackground(String... params) //
	{
		String url = params[0];
		Log.i("doInBackground >", url+"'");
		String picname = Util.urlToFileName(url);
		ZMFilePath fp = new ZMFilePath(ZMFilePath.CARD_ROOT_TYPE,true);
		fp.pushPathNode("tmppic");
		fp.addFileName(picname);
		if(!isBuildImage)
		{
			if(ZMFile.fileExist(fp.toString())) return null;
		}
		boolean ix=ZMFile.fileExist(fp.toString());
		//byte[] tmpPic = ZMFile.readAll(fp.toString());
		if(ix)
		{
			Log.i("LoadImageTsk file exit>", fp.toString());
			/*BitmapFactory.Options opts = new BitmapFactory.Options();
	        opts.inScaled = false;
	        InputStream input = new ByteArrayInputStream(tmpPic);
	        opts.inPreferredConfig = Config.RGB_565;
	        Bitmap bp = BitmapFactory.decodeStream(input, null, opts);*/
	        //Bitmap bp = BitmapFactory.decodeByteArray(tmpPic, 0, tmpPic.length, opts);
	        
	        Bitmap bp =CustomImageView.decodeSampledBitmapFromResource(fp.toString(),
	        		civ.reqWidth, civ.reqHeight);
	        
	        if(null!=bp)
	        {
	        	Log.i("LoadImageTsk>doInBackground>local w-h", bp.getWidth()+"-"+bp.getHeight());
	        }
			return bp;
		}
		iCon =  new IHttpConnect();
		iCon.sendData(null, url);
		byte[] result = iCon.receiveData();
		Bitmap bp =null;
		if(result!=null && result.length>0)
		{
			Log.i("file>", fp.toString());
			ZMFile.delFile(fp.toString());
			ZMFile.write(fp.toString(), result, 0, result.length, 0);
			result=null;
			if(isBuildImage)
			{
				//BitmapFactory.Options opts = new BitmapFactory.Options();
		       // opts.inScaled = false;
		       // bp = BitmapFactory.decodeByteArray(result, 0, result.length, opts);
		        
		       // InputStream input = new ByteArrayInputStream(result);
		      //  opts.inPreferredConfig = Config.RGB_565;
		       // bp = BitmapFactory.decodeStream(input, null, opts);
		        
		        bp =CustomImageView.decodeSampledBitmapFromResource(fp.toString(),
		        		civ.reqWidth, civ.reqHeight);
		        
			}
		}
        
		return bp;
		
	}

	/* (non-Javadoc)
	 * @see android.os.AsyncTask#onCancelled()
	 * Runs on the UI thread after cancel(boolean) is invoked.
	 */
	@Override
	protected void onCancelled() 
	{
		if(null!=iCon)
    	{
    		iCon.disConnect();
    	}
		super.onCancelled();
		flistner.onCancle(this);
		Log.i("onCancelled>", "");
		
		//添加http请求取消
		
	}

	/* (non-Javadoc)
	 * @see android.os.AsyncTask#onPostExecute(java.lang.Object)
	 * Runs on the UI thread after doInBackground(Params...). doInBackground返回的结果
	 * 
	 * 如果有bitmaplistener监听，那么仅调用下载完成 处理，不需要 设置imageview 图片
	 */
	@Override
	protected void onPostExecute( Bitmap object) 
	{
		if(null!=bitmaplistener)
		{
			bitmaplistener.OnImageDownFinish(object,picUrl);
		}
		
		if(null!=object)
		{
			Log.i("onPostExecute >", "pic loadOk");
			if(null!=civ)
			{
				civ.setImageBitmap( object);
			}
			//CustomImageView.this.setImageBitmap( BitmapFactory.decodeByteArray(object, 0, object.length, null));
		}
		if(null!=flistner)
		flistner.onFinished(this);
		
		
	}

	/* (non-Javadoc)
	 * @see android.os.AsyncTask#onPreExecute()
	 * Runs on the UI thread before doInBackground(Params...).
	 */
	@Override
	protected void onPreExecute() 
	{
		// 任务启动，可以在这里显示一个对话框，这里简单处理
	  //  message.setText(R.string.task_started);
	}

	
	/* (non-Javadoc)
	 * @see android.os.AsyncTask#onProgressUpdate(Progress[])
	 * Runs on the UI thread after publishProgress(Progress...) is invoked.
	 */
	@Override
	protected void onProgressUpdate(String... values) 
	{
		// 更新进度
	}
	
	//publishProgress(Progress... values)
	//This method can be invoked from doInBackground(Params...) to publish updates on the UI thread while the background computation is still running.

}
