/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.andframework.common;

import android.app.Service;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;

import com.andframework.business.BaseBusi;
import com.andframework.myinterface.UiCallBack;

// Need the following import to get access to the app resources, since this
// class is in a sub-package.
/*<service android:name="com.jinzhi.msgpoll.common.BackgroundService" />*/

/**
 * This is an example of implementing an application service that can run in the
 * "foreground". It shows how to code this to work well by using the improved
 * Android 2.0 APIs when available and otherwise falling back to the original
 * APIs. Yes: you can take this exact code, compile it against the Android 2.0
 * SDK, and it will against everything down to Android 1.0.
 */
public class BackgroundService extends Service implements UiCallBack, Runnable
{
	public static final String ACTION_BACKGROUND = "BackgroundService";
	
	Thread thread = null;
	
	//final Handler mHandler = new Handler();
	
	CustomNotify customNotify;
	
	
	boolean isStart = true;
	
	@Override
	public void onCreate()
	{
		customNotify = new CustomNotify(this.getApplicationContext(),1, true, null);
		thread = new Thread(this);
		thread.start();
	}
	
	// This is the old onStart method that will be called on the pre-2.0
	// platform. On 2.0 or later we override onStartCommand() so this
	// method will not be called.
	@Override
	public void onStart(Intent intent, int startId)
	{
	}
	
	@Override
	public int onStartCommand(Intent intent, int flags, int startId)
	{
		// handleCommand(intent);
		// We want this service to continue running until it is explicitly
		// stopped, so return sticky.
		return START_STICKY;
	}
	
	@Override
	public void onDestroy()
	{
		// Make sure our notification is gone.
		isStart = false;
	}
	
	@Override
	public IBinder onBind(Intent intent)
	{
		return null;
	}
	
	/**
	 * 消息轮询返回
	 */
	@Override
	public void uiCallBack(BaseBusi obj)
	{
		//if (obj instanceof NewsMsgBusi)
		{
			//NewsMsgParse nmp = (NewsMsgParse) obj.getBaseStruct();
			
			//if (nmp.msgcount> 0)
			{
				customNotify.showNotification(null, null,null, 1, null);
				
			}
			
		}
	}
	
	/**
	 * 发送业务消息
	 */
	final Runnable heart = new Runnable()
	{
		public void run()
		{
			//NewsMsgBusi nmb = new NewsMsgBusi(BackgroundService.this);
			//nmb.iExecute();
		}
	};
	
	@Override
	public void run()
	{
		// TODO Auto-generated method stub
		while (isStart)
		{
			try
			{
				//mHandler.post(heart);
				Thread.sleep(30*60 * 1000);
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}
}
