package com.andframework.common;

import java.util.HashMap;

/**
 * @author xudeliang
 * 对象缓存类，通过key获取及保存对象变量
 *
 */
public class ObjectStores 
{

	/**
	 * 
	 */
	private static ObjectStores inst;
	
	/**
	 * 
	 */
	private HashMap<String,Object> objectStores;
	
	
	/**
	 * 单例模式构造函数
	 */
	private ObjectStores()
	{
		objectStores = new HashMap<String,Object>() ;
	}
	
	/**
	 * @return 单例模式
	 */
	public static ObjectStores getInst()
	{
		if(null ==inst)
		{
			inst = new ObjectStores();
		}
		
		return inst;
	}
	
	
	/**
	 * @param key
	 * @param object
	 */
	public void putObject(String key ,Object object)
	{
		objectStores.put(key, object);
	}
	
	/**
	 * @param key
	 */
	public Object getObject(String key)
	{
		return objectStores.get(key);
	}
	
	/**
	 * @param key
	 */
	public void removeObject(String key)
	{
		objectStores.remove(key);
	}
	
	
}
