package com.andframework.config;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.UTFDataFormatException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;



import android.util.Log;

import com.andframework.zmfile.ZMFile;
import com.andframework.zmfile.ZMFilePath;



/**
 * @author 徐德良
 *该类对应localData.bat
 */
public class LocalData 
{
	/**
	 * 系统是否再提醒升级key
	 */
	public static final String localDataKey_updatetips="localDataKey_updatetips";
	
	private ZMFilePath path = new ZMFilePath(ZMFilePath.CARD_ROOT_TYPE,true);
	private static LocalData inst;
	/**
	 * 保存key value
	 */
	private static HashMap<String,String> localData = new HashMap<String,String>();
	/**
	 * 单例模式构造函数
	 */
	private LocalData()
	{
		initLocalData();
	}
	
	
	private void initLocalData()
	{
		
		path.addFileName("localdata.dat");//.pushPathNode(pathNode)
		
		String localPath = path.toString();
		boolean ret = ZMFile.fileExist(localPath);
		
		if(ret)
		{
			byte[] tmp = ZMFile.readAll(localPath);
			
			ByteArrayInputStream dd = new ByteArrayInputStream(tmp);
			DataInputStream dis = new DataInputStream(dd);
			boolean rett=true;
			while(rett)
			{
				try
				{
					String key =dis.readUTF();
					String value = dis.readUTF();
					localData.put(key, value);
				}
				catch (EOFException e)
				{
					Log.i("LocalData>initLocalData>", "EOFException");
					rett=false;
				}
				catch (IOException e)
				{
					Log.i("LocalData>initLocalData>", "IOException");
					rett=false;
				}
				
				if(!rett)
				{
					try
					{
						dis.close();
						dd.close();
					}
					catch (IOException e)
					{
						e.printStackTrace();
					}
				}
			}
		}
		else
		{
			Log.i("LocalData>initLocalData>", "file not exists");
		}
	}
	
	
	
	/**
	 * @return 单例模式，执行之前确保执行getInst(Context context)
	 */
	public static LocalData getInst()
	{
		if(null ==inst)
		{
			inst = new LocalData();
		}
		
		return inst;
	}
	
	
	
	
	
	/**
	 * 获取配置文件的值
	 * @param key 配置的key
	 */
	public String getLocalValue(String key)
	{
		String value = null;
		if(key!=null && key.length()>0)
		value = localData.get(key);
		return value;
	}
	

	//获取保存文件路径
	public String getLocalDataPath()
	{
		return path.toString();
	}

	
	/**
	 * 设置本地值
	 * @param key 
	 * @param value 
	 */
	public boolean setLocalValue(String key,String value)
	{
		localData.put(key, value);
		ZMFile.delFile(path.toString());
		Iterator it =  localData.entrySet().iterator(); //localData.keySet().iterator();
		FileOutputStream fos=null;
		DataOutputStream dos= null;// new DataOutputStream(fos);
		boolean ret= true;
		try
		{
			File file = new File(path.toString());
			File p = file.getParentFile();
			if (p != null && !p.exists())// 目录不存在创建
			{
				p.mkdirs();
			} 
			
			fos = new FileOutputStream(path.toString(),true);
			dos=  new DataOutputStream(fos);
			while(it.hasNext()) 
			{
				Map.Entry entry =  ( Map.Entry)it.next(); 
				String keytmp = (String)entry.getKey(); 
				String valtmp = (String)entry.getValue();
				
				dos.writeUTF(keytmp);
				dos.writeUTF(valtmp);
				
			}
		}
		catch (FileNotFoundException e)
		{
			ret=false;
			e.printStackTrace();
		}
		catch (UTFDataFormatException  e)
		{
			ret=false;
			e.printStackTrace();
		}
		catch (IOException  e)
		{
			ret=false;
			e.printStackTrace();
		}
		finally
		{
			try
			{
				if(null!=dos)
				{
					dos.close();
				}
				else
				{
					ret=false;
				}
				if(null!=fos)
				{
					fos.close();
				}
				else
				{
					ret=false;
				}
			}
			catch (IOException e)
			{
				ret=false;
				e.printStackTrace();
			}
			
		}
		return ret;
		
		
	}
}
