/**
 * 
 */
package com.andframework.network;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;

/**
 * 上传网络文件的对象
 * 
 * @author 欧建东
 * @email oyjd@163.com
 * 
 */
public class UploadFileVO
{
	private String fileName;// 文件名
	private String contentType = "application/octet-stream";// 文件类型
	private InputStream inputStream;// 文件流

	public UploadFileVO() 
	{
		super();
	}

	public UploadFileVO(String filePath) 
	{
		this(new File(filePath));
	}

	public UploadFileVO(File file) 
	{
		if (null != file && file.exists()) 
		{
			try 
			{
				this.inputStream = new FileInputStream(file);
				this.fileName = file.getName();
			} 
			catch (FileNotFoundException e) 
			{
				e.printStackTrace();
			}
		}

	}

	public UploadFileVO(String fileName, InputStream inputStream) 
	{
		this.fileName = fileName;
		this.inputStream = inputStream;
	}

	public UploadFileVO(String fileName, String contentType, InputStream inputStream) 
	{
		this.fileName = fileName;
		this.contentType = contentType;
		this.inputStream = inputStream;
	}

	public String getFileName() 
	{
		return fileName;
	}

	public void setFileName(String fileName) 
	{
		this.fileName = fileName;
	}

	public String getContentType() {
		return contentType;
	}

	public void setContentType(String contentType) 
	{
		this.contentType = contentType;
	}

	public InputStream getInputStream() 
	{
		return inputStream;
	}

	public void setInputStream(InputStream inputStream) 
	{
		this.inputStream = inputStream;
	}
}
