package com.andframework.parse;

import org.json.JSONException;
import org.json.JSONObject;

import com.andframework.parse.BaseParse;

/**
 * 版本更新解析
 * @author AndrewLeong
 *
 */
public class VersionParse extends BaseParse
{
	/*{
		   “code”:0,
		    "updateflag":"1",
		　　"appname":"1001",
		         "packsize":"1224kb",
		          "updatetime":"xxxx-xx-xx",
		          "des":"升级内容描述"
		}
*/
	public VersionInfo versionInfo = new VersionInfo();
	
	public int code;
	
	@Override
	public boolean parse(byte[] data)
	{
		boolean ret = super.parse(data);
		if (!ret)
		{
			return false;
		}
		if (JSON == parseType)
		{
			try
			{
				if(!jsonObject.isNull("code"))
				{
					code = jsonObject.getInt("code");
				}
			}
			catch(JSONException e)
			{
				e.printStackTrace();
			}
			try
			{
				versionInfo = new VersionInfo();
				versionInfo.appname = jsonObject.getString("appname");
				versionInfo.updateflag = jsonObject.getString("updateflag");
				versionInfo.packsize = jsonObject.getString("packsize");
				versionInfo.updatetime = jsonObject.getString("updatetime");
				versionInfo.des = jsonObject.getString("des");
				versionInfo.packurl= jsonObject.getString("packurl");
				return true;
			}
			catch(JSONException e)
			{
				e.printStackTrace();
			}
			
		}
		return false;
	}
	
	
	public class VersionInfo 
	{
		public String appname="";
		public String updateflag="2";//1表示强制升级，0表示一般升级 ,2表示本版本是最新版本
		public String packsize="";
		public String updatetime="";
		public String des="";
		public String  packurl="";
	}
}
