package com.andframework.ui;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.ref.SoftReference;

import com.andframework.business.LoadImageTsk;
import com.andframework.business.PicDownTaskManager;
import com.andframework.util.Util;
import com.andframework.zmfile.ZMFile;
import com.andframework.zmfile.ZMFilePath;

import android.app.Activity;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.NinePatch;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.PorterDuff.Mode;
import android.graphics.PorterDuffXfermode;
import android.graphics.Rect;
import android.graphics.RectF;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.util.Log;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;

public class CustomImageView extends ImageView implements View.OnTouchListener
{
	
	public static final byte SCALE_BIG = 1;
	public static final byte SCALE_SMALL = 0;

	
	/*缩放规则
	1、放大：大于分辨率宽的图片，最大是原图。小于分辨率宽的图片，最大放大一倍。
	2、缩小：大于分辨率宽的图片，最小是屏幕宽小3/4。小于分辨率宽，不缩小
	*/
	
	/*原图规则
	1、原图宽大于分辨率宽：显示分辨率宽的尺寸。
	2、原图小于分辨率宽：显示原图
	*/
	
	
    //是否滑动支持
    private boolean isFlipMove;
    
    //是否缩放支持
    private boolean isScale;
    
    
    private int maxX = 0;//(int)((bmp.getWidth() / 2) - (controlWidth / 2));
    private int maxY = 0;//(int)((bmp.getHeight() / 2) - (controlHeight / 2));

    // set scroll limits
    private  int maxLeft = (maxX * -1);
    private  int maxRight = maxX;
    private  int maxTop = (maxY * -1);
    private  int maxBottom = maxY;
    
    private  float downX, downY;
    private int totalX, totalY;
    private  int scrollByX, scrollByY;
    private OnScaleFinish onScaleFinish;
    
    //缩放刻度
    private float scale=1.25f;
    
    //屏幕分辨率
    private int screenWidth=0;
    private int screenHeight=0;
    
	float varscale =1f;
    
    private Bitmap bitmap; 
    
   
    
    public int reqWidth; 
    public int reqHeight;
    //图片的url
   // private String picUrl;
    
    public int triangle=0;//1左边三角，2右边三角
    //public boolean isyuanjiao;//true圆角
    public int triangleWidth=0;// 三角宽度
    
    public int minViewW=0;
	public CustomImageView(Context context) 
	{
		super(context);
		Display display = ((Activity)context).getWindowManager().getDefaultDisplay(); 
		screenWidth =display.getWidth();
		screenHeight=display.getHeight();
	}

	public CustomImageView(Context context, AttributeSet attrs) 
	{
		super(context, attrs);
		Display display = ((Activity)context).getWindowManager().getDefaultDisplay(); 
		screenWidth =display.getWidth();
		screenHeight=display.getHeight();
	}

	public CustomImageView(Context context, AttributeSet attrs, int defStyle)
	{
		super(context, attrs, defStyle);
		Display display = ((Activity)context).getWindowManager().getDefaultDisplay(); 
		screenWidth =display.getWidth();
		screenHeight=display.getHeight();
	}
	
	public void setDefaultImage(int resid)
	{
		this.setImageResource(resid);
	}
	
	public void setDefaultImage(Bitmap bitmap)
	{
		 setImageBitmap(bitmap);
	}
	
	//是否缩放支持
	public void setScale(boolean isScale)
	{
		this.isScale = isScale;
	}
	
	//是否滑动支持
	public void setFlipMove(boolean isFlipMove)
	{
		this.isFlipMove = isFlipMove;
		if(isFlipMove)
		{
			this.setOnTouchListener(this);
		}
		else
		{
			this.setOnTouchListener(null);
		}
		
	}
	
	//缩放的时候保留原图片
	@Override
	public void setImageBitmap(Bitmap bp)
	{
		
		if(isScale)
		{
			bitmap=bp;
			
			
			//bitmap
			if(bitmap!=null && screenWidth<bitmap.getWidth())
			{
				float sc = (float)screenWidth/bitmap.getWidth();
				varscale=sc;
				Matrix matrix  = new Matrix();
	            matrix.postScale(sc, sc);
	            Bitmap  bmp = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(), bitmap.getHeight(), matrix, true);
	            super.setImageBitmap(bmp);
			}
			else
			{
				super.setImageBitmap(bitmap);
			}
			
			//通知不能缩小
			if(null!=bitmap &&bitmap.getWidth()<screenWidth)
		    {
				if(null!=onScaleFinish)
				{
					onScaleFinish.OnFinish(SCALE_SMALL);
				}
		    }
		}
		else
		{
			if(minViewW!=0)
			{
				if(bp.getWidth()<minViewW)
			    {
					LinearLayout.LayoutParams ll = (LinearLayout.LayoutParams) getLayoutParams();
			    	int hh=minViewW*bp.getHeight()/bp.getWidth();
				    ll.width=minViewW;
					ll.height=hh;
			    }
			}
			/*if(triangle==2 ||triangle==1)
			{
				Canvas canvas = new Canvas(bitmap);
				LinearLayout.LayoutParams ll = (LinearLayout.LayoutParams) getLayoutParams();
				 int width=ll.width;
					int height=ll.height;
				if(triangle==2 )
				{
					// int saveCount = canvas.getSaveCount();
			           // canvas.save();
			            
					
				//	Paint paint = new Paint();
					paint.setColor(Color.WHITE);
					paint.setAntiAlias(true);
					//Path path = new Path(); //定义一条路径   
				    path.moveTo(width-triangleWidth, 0); //移动到 坐标10,10   
				    path.lineTo(width-triangleWidth, triangleWidth);   
				    path.lineTo(width, triangleWidth+triangleWidth/2);  
				    path.lineTo(width, 0);  
				    path.lineTo(width-triangleWidth, 0);
					canvas.drawPath(path, paint);
					
					
					path.moveTo(width, triangleWidth+triangleWidth/2);  
					path.lineTo(width-triangleWidth, triangleWidth+triangleWidth);  
					path.lineTo(width-triangleWidth, height);  
					path.lineTo(width, height);  
					path.lineTo(width, triangleWidth+triangleWidth/2);  
					
					canvas.drawPath(path, paint);
					 //canvas.restoreToCount(saveCount);
				}
				else if(triangle==1)
				{
					//int width=this.getWidth();
					//int saveCount = canvas.getSaveCount();
		           // canvas.save();
					paint.setColor(Color.WHITE);
					paint.setAntiAlias(true);
				    path.moveTo(0, 0); //移动到 坐标10,10   
				    path.lineTo( triangleWidth, 0);   
				    path.lineTo(triangleWidth, triangleWidth);  
				    path.lineTo(0, triangleWidth+triangleWidth/2);  
				    path.lineTo(0, 0);
					canvas.drawPath(path, paint);
					
					
					path.moveTo(triangleWidth, triangleWidth+triangleWidth);  
					path.lineTo(triangleWidth, height);  
					path.lineTo(0, height);  
					path.lineTo(0, triangleWidth+triangleWidth/2);  
					path.lineTo(triangleWidth, triangleWidth+triangleWidth);  
					
					canvas.drawPath(path, paint);
					
					//canvas.restoreToCount(saveCount);
				}
			}*/
			
			
			
			super.setImageBitmap(bp);
		}
		
		
		
	}
	
	//缩放 0缩小，1放大
	//public static final byte SCALE_BIG = 1;
	//public static final byte SCALE_SMALL = 0;
	public void scale(byte type)
	{
		if(isScale &&null!=bitmap)
		{
			if(type==SCALE_BIG)
			{
				int bmpWidth=bitmap.getWidth();
			    int bmpHeight=bitmap.getHeight();
			    
			    BitmapDrawable mDrawable =  (BitmapDrawable)getDrawable();
			    Bitmap mBitmap = mDrawable.getBitmap();
			    int drawWidth = mBitmap.getWidth();
			    
			    //原图大于屏幕，显示的大等于原图
			    if(bmpWidth>=screenWidth &&drawWidth>=bmpWidth)
			    {
			    	if(null!=onScaleFinish)
			    	onScaleFinish.OnFinish(SCALE_BIG);
			    	return;
			    }
			    
			    //屏幕大等于原图
			    if(bmpWidth<screenWidth &&drawWidth>=bmpWidth*2)
			    {
			    	if(null!=onScaleFinish)
			    	onScaleFinish.OnFinish(SCALE_BIG);
			    	return;
			    }
			    /* 设置图片放大的比例 */
			    varscale=varscale*scale;
			    Matrix matrix  = new Matrix();
	            matrix.postScale(varscale, varscale);
	            Bitmap  bmp = Bitmap.createBitmap(bitmap, 0, 0, bmpWidth, bmpHeight, matrix, true);
	            super.setImageBitmap(bmp);
	            
	            if(bmpWidth<screenWidth &&bmp.getWidth()>=screenWidth*2)
			    {
	            	if(null!=onScaleFinish)
	            	 onScaleFinish.OnFinish(SCALE_BIG);
			    }
	           
			}
			else if(type==SCALE_SMALL)
			{
				int bmpWidth=bitmap.getWidth();
			    int bmpHeight=bitmap.getHeight();
			    
			    BitmapDrawable mDrawable =  (BitmapDrawable)getDrawable();
			    Bitmap mBitmap = mDrawable.getBitmap();
			    int drawWidth = mBitmap.getWidth();
			    
			 
			   
			   //原图小于屏幕，绘制宽度小于 原图宽度0.75倍
			    if( bmpWidth<screenWidth && drawWidth<=bmpWidth*0.75)
			    {
			    	if(null!=onScaleFinish)
			    	onScaleFinish.OnFinish(SCALE_SMALL);
			    	return;
			    }
			    
			    //原图大等于屏幕，缩小比屏幕小0.75
			    if( bmpWidth>=screenWidth && drawWidth<=screenWidth*0.75)
			    {
			    	if(null!=onScaleFinish)
			    	onScaleFinish.OnFinish(SCALE_SMALL);
			    	return;
			    }
			    
			    varscale=varscale/scale;
			    Matrix matrix  = new Matrix();
	            matrix.postScale(varscale, varscale);
	            Bitmap bmp = Bitmap.createBitmap(bitmap, 0, 0, bmpWidth, bmpHeight, matrix, true);
	            super.setImageBitmap(bmp);
	            
	            if(bmp.getWidth()<=bmpWidth*0.75)
	            {
	            	if(null!=onScaleFinish)
	            		onScaleFinish.OnFinish(SCALE_SMALL);
	            }
	           
			}
		}
	}
	
	public void setImageFromeUrl(String url,int reqWidth ,int reqHeight)
	{
		if(null==url || !url.startsWith("http") || url.trim().equals(""))
		{
			Log.i("setImageFromeUrl >", "imageurl null");
			//this.setImageBitmap(null);
			return;
		}
		this.reqWidth=reqWidth;
		this.reqHeight=reqHeight;
		String picname = Util.urlToFileName(url);
		ZMFilePath fp = new ZMFilePath(ZMFilePath.CARD_ROOT_TYPE,true);
		fp.pushPathNode("tmppic");
		fp.addFileName(picname);
		boolean ix=ZMFile.fileExist(fp.toString());
		if(ix)
		{
			//byte[] tmpPic = ZMFile.readAll(fp.toString());
			
			//if(null!=tmpPic)
			//{
				//Log.i("file exit>", tmpPic.length+"'");
				 
		       // opts.inScaled = false;
		       // opts.inSampleSize = 4;
		      //  Bitmap bp = BitmapFactory.decodeByteArray(tmpPic, 0, tmpPic.length, opts);
				Bitmap bp =decodeSampledBitmapFromResource(fp.toString(),
				        reqWidth, reqHeight);
		        //InputStream input = new ByteArrayInputStream(tmpPic);
		      //  SoftReference softRef = new SoftReference(BitmapFactory.decodeStream(input, null, opts));
		      //  Bitmap   bp = (Bitmap)softRef.get();;
		       // opts.inPurgeable = true;   
		       // opts.inInputShareable = true;   
		        
		        
		        //fp.toString()
		        //Bitmap bp = BitmapFactory.decodeStream(input, null, opts);
		        
		        if(null!=bp)
		        {
		        	Log.i("CustomImageView>setImageFromeUrl>local w-h", bp.getWidth()+"-"+bp.getHeight());
		        }
		        
		       
		        this.setImageBitmap(bp);
		        
		          
		        return;
			//}
		}
		
		LoadImageTsk lit = new LoadImageTsk();
		lit.picUrl=url;
		lit.setImageView(this);
		PicDownTaskManager.getInst().postTask(lit);
	}
	
	//处理监听事件
	@Override
	public boolean onTouch(View view, MotionEvent event)
    {
        float currentX, currentY;
        switch (event.getAction())
        {
            case MotionEvent.ACTION_DOWN:
                downX = event.getX();
                downY = event.getY();
                break;

            case MotionEvent.ACTION_MOVE:
                currentX = event.getX();
                currentY = event.getY();
                scrollByX = (int)(downX - currentX);
                scrollByY = (int)(downY - currentY);

                // scrolling to left side of image (pic moving to the right)
                if (currentX > downX)
                {
                    if (totalX == maxLeft)
                    {
                        scrollByX = 0;
                    }
                    if (totalX > maxLeft)
                    {
                        totalX = totalX + scrollByX;
                    }
                    if (totalX < maxLeft)
                    {
                        scrollByX = maxLeft - (totalX - scrollByX);
                        totalX = maxLeft;
                    }
                }

                // scrolling to right side of image (pic moving to the left)
                if (currentX < downX)
                {
                    if (totalX == maxRight)
                    {
                        scrollByX = 0;
                    }
                    if (totalX < maxRight)
                    {
                        totalX = totalX + scrollByX;
                    }
                    if (totalX > maxRight)
                    {
                        scrollByX = maxRight - (totalX - scrollByX);
                        totalX = maxRight;
                    }
                }

                // scrolling to top of image (pic moving to the bottom)
                if (currentY > downY)
                {
                    if (totalY == maxTop)
                    {
                        scrollByY = 0;
                    }
                    if (totalY > maxTop)
                    {
                        totalY = totalY + scrollByY;
                    }
                    if (totalY < maxTop)
                    {
                        scrollByY = maxTop - (totalY - scrollByY);
                        totalY = maxTop;
                    }
                }

                // scrolling to bottom of image (pic moving to the top)
                if (currentY < downY)
                {
                    if (totalY == maxBottom)
                    {
                        scrollByY = 0;
                    }
                    if (totalY < maxBottom)
                    {
                        totalY = totalY + scrollByY;
                    }
                    if (totalY > maxBottom)
                    {
                        scrollByY = maxBottom - (totalY - scrollByY);
                        totalY = maxBottom;
                    }
                }

                this.scrollBy(scrollByX, scrollByY);
                downX = currentX;
                downY = currentY;
                break;

        }

        return true;
    }
	Paint paint = new Paint();
	Path path = new Path();
	@Override
	public void onDraw(Canvas canvas)
	{
		//if(null!=canvas)
		//canvas.drawColor(Color.TRANSPARENT, android.graphics.PorterDuff.Mode.CLEAR);  
		super.onDraw(canvas);
		//int width =getWidth();
		Drawable mDrawable1 =  getDrawable();
		if(null!=mDrawable1 && mDrawable1 instanceof BitmapDrawable )
		{
			BitmapDrawable mDrawable=(BitmapDrawable)mDrawable1;
			  Bitmap mBitmap = mDrawable.getBitmap();
				if(null!=mBitmap &&isFlipMove)
				{
					maxX = mBitmap.getWidth();//(int)((bitmap.getWidth() / 2) - (this.getWidth() / 2));
					maxY =mBitmap.getHeight();// (int)((bitmap.getHeight() / 2) - (this.getHeight() / 2));

					//Log.i("maxX:maxY", maxX+":"+maxY);

					// set scroll limits
					maxLeft = (maxX * -1);
					maxRight = maxX;
					maxTop = (maxY * -1);
					maxBottom = maxY;
				}
		}
		
		
		if(triangle==2 && minViewW>0)
		{
			LinearLayout.LayoutParams ll = (LinearLayout.LayoutParams) getLayoutParams();
			 int width=ll.width;
				int height=ll.height;
			if(minViewW>=width)
			{
				paint.setColor(Color.WHITE);
				paint.setAntiAlias(true);
				//Path path = new Path(); //定义一条路径   
			    path.moveTo(width-triangleWidth, 0); //移动到 坐标10,10   
			    path.lineTo(width-triangleWidth, triangleWidth);   
			    path.lineTo(width, triangleWidth+triangleWidth/2);  
			    path.lineTo(width, 0);  
			    path.lineTo(width-triangleWidth, 0);
				canvas.drawPath(path, paint);
				
				
				path.moveTo(width, triangleWidth+triangleWidth/2);  
				path.lineTo(width-triangleWidth, triangleWidth+triangleWidth);  
				path.lineTo(width-triangleWidth, height);  
				path.lineTo(width, height);  
				path.lineTo(width, triangleWidth+triangleWidth/2);  
				
				canvas.drawPath(path, paint);
			}
			 
		}
		else if(triangle==1 && minViewW>0)
		{
			LinearLayout.LayoutParams ll = (LinearLayout.LayoutParams) getLayoutParams();
			 int width=ll.width;
				int height=ll.height;
			if(minViewW>=width)
			{
			paint.setColor(Color.WHITE);
			paint.setAntiAlias(true);
		    path.moveTo(0, 0); //移动到 坐标10,10   
		    path.lineTo( triangleWidth, 0);   
		    path.lineTo(triangleWidth, triangleWidth);  
		    path.lineTo(0, triangleWidth+triangleWidth/2);  
		    path.lineTo(0, 0);
			canvas.drawPath(path, paint);
			
			
			path.moveTo(triangleWidth, triangleWidth+triangleWidth);  
			path.lineTo(triangleWidth, height);  
			path.lineTo(0, height);  
			path.lineTo(0, triangleWidth+triangleWidth/2);  
			path.lineTo(triangleWidth, triangleWidth+triangleWidth);  
			
			canvas.drawPath(path, paint);
			}
			 
		}
		
		    
	}
	
	//设置缩放监听器
	public void setOnScaleFinish(OnScaleFinish onScaleFinish)
	{
		this.onScaleFinish=onScaleFinish;
	}

	//缩放监听
	public interface OnScaleFinish
	{
        //SCALE_BIG = 1;
        //SCALE_SMALL = 0;
		public void OnFinish(byte scaletType);
	}
       
	public static int calculateInSampleSize(BitmapFactory.Options options, int reqWidth, int reqHeight) {
    // Raw height and width of image
    final int height = options.outHeight;
    final int width = options.outWidth;
    int inSampleSize = 1;

    if (height > reqHeight || width > reqWidth) {

        final int halfHeight = height / 2;
        final int halfWidth = width / 2;

        // Calculate the largest inSampleSize value that is a power of 2 and keeps both
        // height and width larger than the requested height and width.
        while ((halfHeight / inSampleSize) >= reqHeight
                && (halfWidth / inSampleSize) >= reqWidth) {
            inSampleSize *= 2;
        }
    }

    return inSampleSize;
}
	public static Bitmap decodeSampledBitmapFromResource(String pathName,
	        int reqWidth, int reqHeight) {

	    // First decode with inJustDecodeBounds=true to check dimensions
	    final BitmapFactory.Options options = new BitmapFactory.Options();
	    options.inJustDecodeBounds = true;
	     
	    Bitmap  bmp = BitmapFactory.decodeFile(pathName, options);//;.decodeResource(res, resId, options);

	    if(null!=bmp && !bmp.isRecycled() ){
	         bmp.recycle();   //回收图片所占的内存
	         System.gc();  //提醒系统及时回收
	    }
	    // Calculate inSampleSize
	    if(reqWidth>0 && reqHeight>0)
	    options.inSampleSize = calculateInSampleSize(options, reqWidth, reqHeight);

	    // Decode bitmap with inSampleSize set
	    options.inJustDecodeBounds = false;
	    options.inPreferredConfig = Config.RGB_565;
	    options.inPurgeable = true;  
	    options.inInputShareable = true;
	   // return BitmapFactory.decodeResource(res, resId, options);
	    return BitmapFactory.decodeFile(pathName, options);
	}
	
	/*public void setReqSize(int reqWidth, int reqHeight)
	{
		this.reqWidth=reqWidth;
		this.reqHeight=reqHeight;
	}*/
}
