/**
 * 
 */
package com.andframework.ui;

import java.util.HashMap;
import java.util.Random;


import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.RectF;
import android.util.AttributeSet;
import android.util.Log;
import android.view.View;
import android.webkit.WebView;

/**
 * @author xudeliang
 *
 */
public class ProgressView extends View
{
	private Paint paint;  
	
	
	private int viewWidth=1;
	private int viewHeight=1;
	private int progress=1;//1到100
	
	
	//int scalGap=12;
	
	//int maxXnum=33;
	/**
	 * @param context
	 */
	public ProgressView(Context context)
	{
		super(context);
		init();
	}
	public void onProgressChanged( int progress)
	{
		this.progress=progress;
		this.invalidate();
	}
	private void init()
	{
		paint = new Paint();  
        paint.setAntiAlias(true); // 设置画笔无锯齿  
        paint.setColor(Color.RED); 
        paint.setStrokeWidth(4);
        this.setBackgroundColor(Color.GRAY);
      
	}
	
	public ProgressView(Context context, AttributeSet attrs) 
	{
		super(context, attrs);
		init();
	}
	
	
	@Override
	protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
	    super.onMeasure(widthMeasureSpec, heightMeasureSpec);

	    viewWidth= MeasureSpec.getSize(widthMeasureSpec);
	    viewHeight = MeasureSpec.getSize(heightMeasureSpec);
	}
	protected void onDraw(Canvas canvas) 
	{
		super.onDraw(canvas);
		
		float pro=(float)progress/100f;
		if(progress>90)pro=1f;
		
		float w=viewWidth*pro;
		
		canvas.drawLine(0, 0,  w, 0, paint);//y轴

	}
}
