/**
 * 
 */
package com.andframework.ui;



import java.util.ArrayList;

import com.andframework.R;


import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.util.AttributeSet;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.HorizontalScrollView;
import android.widget.LinearLayout;

/**
 * @author xudeliang
 *
 */
public class ScrollView extends LinearLayout
{
	private Activity context;
	
	//Bitmap itemFocusImage;
	private LinearLayout scrollPanel;
	
	private OnClickListener cl;
	private Button currentClick;
	
	/**
	 * @param context
	 */
	public ScrollView(Context context)
	{
		super(context);
		this.context =(Activity)context;
		initGUI();
	}
	
	/**
	 * @param context
	 * @param attrs
	 */
	public ScrollView(Context context, AttributeSet attrs)
	{
		super(context, attrs);
		this.context =(Activity)context;
		initGUI();
	}
	
	/**
	 * 初始化ui
	 */
	private void initGUI()
	{
		LayoutInflater ly = (LayoutInflater)context. getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
		View view = ly.inflate(R.layout.pub_scrollview, this,true);
		scrollPanel = (LinearLayout) view.findViewById(R.id.buttonboard);
		HorizontalScrollView hsv = (HorizontalScrollView) view.findViewById(R.id.hsv);
		hsv.setHorizontalScrollBarEnabled(false);
		
		/*TextAndTag [] textAndTag= new TextAndTag[10];
		for(int i=0;i<textAndTag.length;i++)
		{
			textAndTag[i] = new TextAndTag();
			textAndTag[i].text="阿旦发"+i;
		}
		buildUIFromTexts(textAndTag);*/
	}
	
	
	/**
	 * listener 点击监听
	 */
	public void setItemClickListener(OnClickListener listener)
	{
		cl=listener;
	}
	
	/**
	 * textAndTag 显示文本的数据对象
	 */
	
	public void buildUIFromTexts(ArrayList<TextAndTag> textAndTag)
	{
		if(textAndTag==null || textAndTag.size()==0)
		{
			return;
		}
		
		TextAndTag[] textAndTags = new TextAndTag[textAndTag.size()];
		for(int i=0;i<textAndTag.size();i++)
		{
			textAndTags[i] = textAndTag.get(i);
		}
		buildUIFromTexts(textAndTags);
	}
	
	
	/**
	 * textAndTag 显示文本的数据对象
	 */
	public void buildUIFromTexts(TextAndTag[] textAndTag)
	{
		if(textAndTag==null || textAndTag.length==0)
		{
			return;
		}
		
		
		for (int i = 0; i < textAndTag.length; i++)
		{
			Button tmpButton = new Button(context);
			tmpButton.setText(textAndTag[i].text);
			tmpButton.setTag(textAndTag[i].obj);
			tmpButton.setBackgroundColor(Color.TRANSPARENT);
			tmpButton.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 16);
			tmpButton.setTextColor(Color.WHITE);
			tmpButton.setPadding(tmpButton.getPaddingLeft(), 0, tmpButton.getPaddingRight(), 0);
			
			tmpButton.setGravity(Gravity.CENTER);
			if (i == 0)
			{
				currentClick = tmpButton;
				currentClick.setBackgroundResource(R.drawable.scrollbutton);
				currentClick.setTextColor(Color.parseColor("#0099cc"));//.setTextColor(Color.WHITE);
			}
			
			scrollPanel.addView(tmpButton);
			
			tmpButton.setOnClickListener(new OnClickListener()
			{
				@Override
				public void onClick(View v)
				{
					currentClick.setTextColor(Color.WHITE);
					currentClick.setBackgroundColor(Color.TRANSPARENT);
					currentClick=(Button)v;
					currentClick.setBackgroundResource(R.drawable.scrollbutton);
					currentClick.setTextColor(Color.parseColor("#0099cc"));
					if(null!=cl)
					{
						cl.onClick(v);
					}
				}
			});
		}
	}
	
	public class TextAndTag
	{
		public String text;
		public Object obj;
	}
}
