/**
 * 
 */
package com.andframework.ui;

import com.andframework.business.FinishedListner;
import com.andframework.business.LoadImageTsk;
import com.andframework.util.Util;
import com.andframework.zmfile.ZMFile;
import com.andframework.zmfile.ZMFilePath;

import android.content.Context;
import android.graphics.Color;
import android.util.AttributeSet;
import android.util.Log;
import android.view.Gravity;
import android.webkit.WebSettings;
import android.webkit.WebSettings.ZoomDensity;
import android.webkit.WebView;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.TextView;

/**
 * @author xudeliang
 *
 */
public class ZoomImageView extends FrameLayout   implements FinishedListner
{

	FinishedListner finishedListner;
	private WebView scaleView;
	public int screentWidth=0;
	public TextView loading;
	
	/**
	 * @param attrs
	 */
	public ZoomImageView(Context context)
	{
		super(context);
		init();
	}
	
	/**
	 * @param context
	 * @param attrs
	 */
	public ZoomImageView(Context context, AttributeSet attrs)
	{
		super(context, attrs);
		init();
	}
	
	
	/**
	 * @param path 不为空，以http开头 则需要网络请求，或者本地文件
	 */
	public void loadImageView(String path)
	{
		//LoadDataWithBaseURL 
		if(path.startsWith("http"))
		{
			String picname = Util.urlToFileName(path);
			final ZMFilePath fp = new ZMFilePath(ZMFilePath.CARD_ROOT_TYPE,true);
			fp.pushPathNode("tmppic");
			fp.addFileName(picname);
			if(!ZMFile.fileExist(fp.toString()))
			{
				LoadImageTsk lit = new LoadImageTsk();
				lit.setBuildImage(false);
				lit.picUrl=path;
				lit.setFinishedListner(this);
				lit.iExcute();
				
				/*AsyncHttpClient asc  =  new AsyncHttpClient();
				asc.get(path, new BinaryHttpResponseHandler(){
					@Override
		            public void onSuccess(byte[] fileData) {
						if(fileData!=null && fileData.length>0)
						{
							ZMFile.write(fp.toString(), fileData, 0, fileData.length, 0);
							Log.i("finish", fileData.length+"");
							
						}
		            }
				});*/
				
			}
			else
			{
				String cont = getImageHtml(fp.toString());
				scaleView.loadDataWithBaseURL(null, cont,"text/html", "utf-8", null);
				scaleView.invalidate();
				LoadImageTsk lit = new LoadImageTsk();
				lit.setBuildImage(false);
				lit.picUrl=path;
				if(null!=finishedListner)finishedListner.onFinished(lit);
			}
			
		}
		else//文件路径
		{
			String cont = getImageHtml(path);
			scaleView.loadDataWithBaseURL(null, cont,"text/html", "utf-8", null);
			scaleView.invalidate();
			LoadImageTsk lit = new LoadImageTsk();
			lit.setBuildImage(false);
			lit.picUrl=path;
			if(null!=finishedListner)finishedListner.onFinished(lit);
		}
		
	}
	/*
	1、设置缩放按钮是否课教案
	
	*/
	public void setZoomControlsVisible(boolean bool)
	{
		WebSettings setting = scaleView.getSettings();
		setting.setBuiltInZoomControls(bool); // 设置出现缩放工具
	}
	
	private String getImageHtml(String imagePath)
	{
		//file:///sdcard/d
		String path="file://"+imagePath;
		/*if(imagePath.startsWith("//"))
		{
			path="file:"+imagePath;
		}
		else if(imagePath.startsWith("/"))
		{
			path="file:/"+imagePath;
		}
		else 
		{
			path="file://"+imagePath;
		}*/
		//int webh=100;//Util.dip2px(getContext(), 688);
		//webh=webh/2-;
		//Log.i("webview h=", webh+"");
		//String cont = "<html>"+
		//"<head></head>"+
		//"<body> <center>"+
		//"<img src=\""+ path+ "\"  "+" />"+
		///"</center> </body>"+
		//"</html>"; 
		//<meta name=\"viewport\"\"content=\"width="+screentWidth+", initial-scale=0.65 \" />
		String cont ="<html>"+
		"<head></head>"+
		"<body>"+
		"<table width=\"100%\" height=\"100%\">"+
			"<tr>"+
				"<td width=\"100%\" height=\"100%\" align=\"center\" valign=\"middle\"><img width=\""+screentWidth+"\" src= \""+path+"\"/></td>"+
			"</tr>"+
		"</table>"+
		"</body>"+
		"</html>";
		
		
		//Log.i("content", cont);
		return cont;
	}
	
	public void setInitialScale(int scale)
	{
		scaleView.setInitialScale(scale); 
	}
	public void setDefaultZoom(ZoomDensity zoom)
	{
		 scaleView.getSettings().setDefaultZoom(zoom);
	}
	public WebView getZoomView()
	{
		return scaleView;
	}
	private void init()
	{
		scaleView =new WebView(this.getContext());
		this.setBackgroundColor(Color.TRANSPARENT);
		FrameLayout.LayoutParams scly = new FrameLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT,LinearLayout.LayoutParams.MATCH_PARENT);
		scly.gravity=Gravity.CENTER;
		
		loading=new TextView(this.getContext());
		loading.setText("正在加载中...");
		loading.setGravity(Gravity.CENTER);
		this.addView(loading,scly);
		
		scly = new FrameLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT,LinearLayout.LayoutParams.MATCH_PARENT);
		scly.gravity=Gravity.CENTER;
		this.addView(scaleView,scly);
		
		WebSettings set = scaleView.getSettings();
		
		//set.setJavaScriptEnabled(true);// 可用JS
		scaleView.setScrollBarStyle(0);// 滚动条风格，为0就是不给滚动条留空间，滚动条覆盖在网页上
		set.setSupportZoom(true);
		set.setBuiltInZoomControls(true);
		//set.setUseWideViewPort(true); 
		scaleView.setInitialScale(39); 
		//getSettings().setUseWideViewPort(true);  
        
		set.setAllowFileAccess(true);
		/*int screenDensity = getResources().getDisplayMetrics().densityDpi;
		ZoomDensity zoomDensity = ZoomDensity.MEDIUM;
		switch(screenDensity){
		case DisplayMetrics.DENSITY_LOW:
		    zoomDensity = ZoomDensity.CLOSE;
		    break;
		case DisplayMetrics.DENSITY_MEDIUM:
		    zoomDensity = ZoomDensity.MEDIUM;
		    break;
		case DisplayMetrics.DENSITY_HIGH:
		    zoomDensity = ZoomDensity.FAR;
		    break;
		}*/
		set.setDefaultZoom(ZoomDensity.CLOSE);
		//set.setBlockNetworkImage(false);
		//set.setLayoutAlgorithm(LayoutAlgorithm.SINGLE_COLUMN);
		scaleView.setBackgroundColor(0);
		scaleView.setHorizontalScrollBarEnabled(false);//水平不显示
		scaleView.setVerticalScrollBarEnabled(false); //垂直不显示
	}

	/* (non-Javadoc)
	 * @see com.andframework.business.FinishedListner#onCancle(com.andframework.business.LoadImageTsk)
	 */
	@Override
	public void onCancle(LoadImageTsk arg0)
	{
		// TODO Auto-generated method stub
		if(null!=finishedListner)finishedListner.onCancle(arg0);
	}

	/* (non-Javadoc)
	 * @see com.andframework.business.FinishedListner#onFinished(com.andframework.business.LoadImageTsk)
	 */
	@Override
	public void onFinished(LoadImageTsk arg0)
	{
		// TODO Auto-generated method stub
		String picname = Util.urlToFileName(arg0.picUrl);
		ZMFilePath fp = new ZMFilePath(ZMFilePath.CARD_ROOT_TYPE,true);
		fp.pushPathNode("tmppic");
		fp.addFileName(picname);
		if(ZMFile.fileExist(fp.toString()))
		{
			/*String cont = "<html>"+
			"<head></head>"+
			"<body>"+
			"<img src=\""+ fp.toString()+ "\" />"+
			"</body>"+
			"</html>";*/
			String cont = getImageHtml(fp.toString());
			scaleView.loadDataWithBaseURL(null, cont,"text/html", "utf-8", null);
			scaleView.invalidate();
		}
		if(null!=finishedListner)finishedListner.onFinished(arg0);
		
	}
	
	public void setLoadViewCallback(FinishedListner f)
	{
		finishedListner=f;
	}
}
