/**
 * 
 */
package com.andframework.ui;

import android.content.Context;
import android.graphics.Color;
import android.util.AttributeSet;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.FrameLayout;
import android.widget.LinearLayout;

/**
 * @author xudeliang
 * 缩放图片控件
 */
public class ZoomView extends FrameLayout
{
	
	/**
	 * 缩放控件
	 */
	private WebView scaleView;
	private Context context;
	
	/**
	 * @param context
	 */
	public ZoomView(Context context)
	{
		super(context);
		this.context=context;
		initUI();
	}
	
	/**
	 * @param context
	 * @param attrs
	 */
	public ZoomView(Context context, AttributeSet attrs)
	{
		super(context, attrs);
		this.context=context;
		initUI();
	}
	
	/**
	 * @param context
	 * @param attrs
	 * @param defStyle
	 */
	public ZoomView(Context context, AttributeSet attrs, int defStyle)
	{
		super(context, attrs, defStyle);
		this.context=context;
		initUI();
	}
	
	/**
	 * 初始化
	 */
	private void initUI()
	{
		scaleView =new WebView(context);
		this.setBackgroundColor(Color.WHITE);
		LinearLayout.LayoutParams scly = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.FILL_PARENT,LinearLayout.LayoutParams.FILL_PARENT);
		this.addView(scaleView,scly);
		
		/*WebSettings setting = scaleView.getSettings();
		setting.setJavaScriptEnabled(true);// 可用JS
		setting.setSupportZoom(true); // 设置可以支持缩放
		setting.setBuiltInZoomControls(true); // 设置出现缩放工具
		setting.setDatabaseEnabled(false);*/
	}
	
	/*
	1、支持http url的路径
	2、支持本地文件路径
	*/
	public void showZoomImage(String picurl)
	{
		if(null==picurl)
		{
			return;
		}
		WebSettings setting = scaleView.getSettings();
		setting.setJavaScriptEnabled(true);// 可用JS
		setting.setSupportZoom(true); // 设置可以支持缩放
		setting.setBuiltInZoomControls(true); // 设置出现缩放工具
		setting.setDatabaseEnabled(false);
		if(picurl.contains("/mnt/")) 
		{
			picurl=picurl.replace("/mnt/", "file:///");
		}
		
		String html =  ("<html><center><img src=\""+ picurl+"\" ></html>" );
		scaleView.loadDataWithBaseURL(null,html,"text/html","UTF-8",null);
	}
	
	/*
	1、设置缩放按钮是否课教案
	
	*/
	public void setZoomControlsVisible(boolean bool)
	{
		WebSettings setting = scaleView.getSettings();
		setting.setBuiltInZoomControls(bool); // 设置出现缩放工具
	}
	
}
